/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.gui.FieldBasedUI.SubsetGUI;

import java.util.ArrayList;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class SubsetUI extends javax.swing.JPanel
{
    private SubsetParams params = null;
    private boolean active = true;
    /**
     * Creates new form DownsizeUI
     */
    public SubsetUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        preferredSizeSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        jPanel1 = new javax.swing.JPanel();
        randomButton = new javax.swing.JRadioButton();
        regularButton = new javax.swing.JRadioButton();
        centerBox = new javax.swing.JCheckBox();

        setBorder(javax.swing.BorderFactory.createTitledBorder("preferred subset size"));
        setLayout(new java.awt.GridBagLayout());

        preferredSizeSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.INT);
        preferredSizeSlider.setGlobalMin(1);
        preferredSizeSlider.setMax(100000);
        preferredSizeSlider.setMin(1);
        preferredSizeSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        preferredSizeSlider.setSubmitOnAdjusting(false);
        preferredSizeSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                preferredSizeSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(preferredSizeSlider, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridLayout(1, 0));

        buttonGroup1.add(randomButton);
        randomButton.setSelected(true);
        randomButton.setText("random");
        randomButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                randomButtonActionPerformed(evt);
            }
        });
        jPanel1.add(randomButton);

        buttonGroup1.add(regularButton);
        regularButton.setText("regular");
        regularButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                regularButtonActionPerformed(evt);
            }
        });
        jPanel1.add(regularButton);

        centerBox.setSelected(true);
        centerBox.setText("center");
        centerBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                centerBoxActionPerformed(evt);
            }
        });
        jPanel1.add(centerBox);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void preferredSizeSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_preferredSizeSliderUserChangeAction
        params.setAdjusting(preferredSizeSlider.isAdjusting());
        params.setSubsetSize((int)preferredSizeSlider.getValue());
    }//GEN-LAST:event_preferredSizeSliderUserChangeAction

    private void centerBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_centerBoxActionPerformed
        params.setCentered(centerBox.isSelected());
    }//GEN-LAST:event_centerBoxActionPerformed

    private void regularButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_regularButtonActionPerformed
        params.setRandom(!regularButton.isSelected());
        centerBox.setEnabled(regularButton.isSelected());
    }//GEN-LAST:event_regularButtonActionPerformed

    private void randomButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_randomButtonActionPerformed
        params.setRandom(randomButton.isSelected());
        centerBox.setEnabled(!randomButton.isSelected());
    }//GEN-LAST:event_randomButtonActionPerformed

    public void setParams(SubsetParams params)
    {
        this.params = params;
        params.setUI(this);
    }

    public void updateFromParams()
    {
        if (params == null)
            return;
        active = false;
        preferredSizeSlider.setAll(params.getMinSize(), 
                                   params.getMaxSize(), 
                                   params.getPreferredSize());
        regularButton.setSelected(params.isRegularAvailable());
        randomButton.setSelected(!params.isRegularAvailable());
    }
    
    public void showRegularDownsizeWidgets(boolean show)
    {
        regularButton.setVisible(show);
        centerBox.setVisible(show);
        centerBox.setEnabled(regularButton.isSelected());
    }
    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList = new ArrayList<>();

    /**
     * Registers ChangeListener to receive events.
     *
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     *
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    private void fireStateChanged()
    {
        if (active) {
            ChangeEvent e = new ChangeEvent(this);
            for (ChangeListener listener : changeListenerList)
                listener.stateChanged(e);
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JCheckBox centerBox;
    private javax.swing.JPanel jPanel1;
    private org.visnow.vn.gui.widgets.ExtendedSlider preferredSizeSlider;
    private javax.swing.JRadioButton randomButton;
    private javax.swing.JRadioButton regularButton;
    // End of variables declaration//GEN-END:variables

}
